#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype.h>

#define GUESTBOOK_FILE "/home/fria/gemini/guestbook.gmi"

void urldecode2(char *dst, const char *src) {
	char a, b;
	while (*src) {
		if	((*src == '%') && 
				((a = src[1]) && (b = src[2])) &&
				(isxdigit(a) && isxdigit(b))) {

			if (a >= 'a') a -= 'a'-'A';
			if (a >= 'A') a -= ('A' - 10);
			else  a -= '0';

			if (b >= 'a') b -= 'a'-'A';
			if (b >= 'A') b -= ('A' - 10);
			else b -= '0';

			*dst++ = 16*a+b;
			src+=3;
		} else if (*src == '+') {
			*dst++ = ' ';
			src++;
		} else {
			*dst++ = *src++;
		}
	}
	*dst++ = '\0';
}



int main() {
	char *input=getenv("QUERY_STRING");
	FILE *fp=NULL;
	time_t t = time(NULL);
	struct tm tm = *localtime(&t);
	char *output=NULL;
	
	if(!(input && *input)) {
		printf("10 Enter message?\r\n");
		exit(0);
	}

	output=malloc(strlen(input)+1);
	urldecode2(output,input);

	fp=fopen(GUESTBOOK_FILE,"a");
	fprintf(fp,"### %d-%02d-%02d %02d:%02d:%02d\n%s\n",tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,output);
	fclose(fp);

	free(output);
	output=NULL;
	
	printf("30 /cgi-bin/guestbook/view.cgi\r\n");
	
	return 0;
}
